`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    18:53:51 03/04/2010 
// Design Name: 
// Module Name:    SCREEN_BUFFER 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module SCREEN_BUFFER(
pixel_clock,
pixel_count0,
line_count0,

X,
Y,
spriteID,
draw,
/*
led0,
led1,
led2,
*/
vga_red_data,
vga_green_data,
vga_blue_data
);

input				pixel_clock;
input [10:0] 	pixel_count0;
input [9:0]		line_count0;

input [15:0]	X;
input [15:0]	Y;
input [7:0]		spriteID;
input 			draw;
/*
output			led0;
output			led1;
output			led2;
*/
output [7:0]	vga_red_data;
output [7:0]	vga_green_data;
output [7:0]	vga_blue_data;

reg [0:639]		pixel_count;
reg [0:479]		line_count;

reg [7:0]		red_factor;
reg [7:0]		green_factor;
reg [7:0]		blue_factor;

reg [0:639]big_array[0:479];
//reg [0:639]green_2D_array[0:479];

reg [0:639]colour_read;
reg [0:639]colour_write;
//reg [0:639]green_read;
//reg [0:639]green_write;

wire [7:0]		red_data			= red_factor;
wire [7:0]		green_data		= green_factor;
wire [7:0]		blue_data		= blue_factor;

wire [10:0]		write_addr = {!line_count0[0], pixel_count0[9:0]};
wire [10:0]		read_addr = {line_count0[0], pixel_count0[9:0]};
wire				write_enable	= 1'b1; // write every clock posedge

reg drawpaddle1, drawpaddle2, drawpong;

reg [15:0] paddle1_X, paddle2_X, pong_X;
reg [15:0] paddle1_Y, paddle2_Y, pong_Y;
//need a different offset for pong.

integer newScreen;

//assign led0 = ~draw;
/*
assign led0 = ~spriteID[0];
assign led1 = ~spriteID[1];
assign led2 = ~spriteID[2];
*/

initial
begin
	newScreen = 0;
	drawpaddle1 = 0;
	drawpaddle2 = 0;
end

//drawing stuffz
//reg [15:0]	X;
//reg [15:0]	Y;
//reg [7:0]	spriteID;


//OPC from COLOR_BARS

always @ (posedge pixel_clock) begin
	if ((line_count0 == (`V_TOTAL - 2)) & (pixel_count0 == (`H_TOTAL - 3)))
		// last pixel in last line of frame, so reset line counter
		line_count <= 9'h000;
	
	else if (pixel_count0 == (`H_TOTAL - 3))
		// last pixel but not last line, so increment line counter
		line_count <= line_count + 1;
end

// compensate for putting the pixel_count generation and the code that
// checks it on the same clock edge
always @ (posedge pixel_clock) begin
	if ((pixel_count0 == (`H_TOTAL - 3)))
		// last pixel in last line of frame, so reset line counter
		pixel_count <= 10'h000;
	
	else
		// last pixel but not last line, so increment line counter
		pixel_count <= pixel_count + 1;
end

always @ (posedge pixel_clock) begin
	if(pixel_count == 0 && line_count == 0 && newScreen < 11) //10 cycles of draw, state 11 is clear
		newScreen <= newScreen + 1;
	else
		newScreen <= 0;
end

//End of OPC

always @ (posedge pixel_clock) begin
			colour_read[0:639] <= big_array[line_count];
			if( colour_read[pixel_count] == 1) begin
				green_factor[7:0] <= 8'hFF;
				blue_factor[7:0] <= 8'h00;
			end
			else begin
				red_factor[7:0] <= 8'h00;
				green_factor[7:0] <= 8'h00;
				blue_factor[7:0] <= 8'hFF;
			end
					
end

//This draws a small red rectangle in the upper right corner of the screen buffer, red_2D_array.
always @ (posedge draw) begin
		if(spriteID == 8'b00000001) begin
			paddle1_X <= X;
			paddle1_Y <= Y;
			drawpaddle1 <= 1;
		end
		if(spriteID == 8'b00000011) begin
			paddle2_X <= X;
			paddle2_Y <= Y;
			drawpaddle2 <= 1;
		end
end

always @ (posedge pixel_clock) begin
		big_array[line_count] <= colour_write[0:639];
		if(newScreen < 10) begin
			if(pixel_count > 580 && pixel_count < 590 && line_count > 10 && line_count < 60) begin
				colour_write[pixel_count] <= 1;
				end
				else begin
				colour_write[pixel_count] <= 0;
			end //This draws a paddle in the top right corner. We want to emulate this without the pixel clock.
			if(drawpaddle1 == 1 && pixel_count > paddle1_X && pixel_count < paddle1_X+10 && line_count > paddle1_Y && 
				line_count < paddle1_Y+50) begin
			colour_write[pixel_count] <= 1;
			end
			/*if(drawpaddle1 == 0 && pixel_count > paddle1_X && pixel_count < paddle1_X+10 && line_count > paddle1_Y && 
				line_count < paddle1_Y+50) begin
			colour_write[pixel_count] <= 0;
			end*/
			if(drawpaddle2 == 1 && pixel_count > paddle2_X && pixel_count < paddle2_X+10 && line_count > paddle2_Y && 
				line_count < paddle2_Y+50) begin
				colour_write[pixel_count] <= 1;
			end
		end
		else
			colour_write[pixel_count] <= 0;
end	

VIDEO_RAM RED_RAM
(
pixel_clock,		// write clock
write_enable,		// write enable
write_addr,			// write address
red_data,			// write data

pixel_clock,		// read clock
read_addr,			// read address
vga_red_data		// read data
);

VIDEO_RAM GREEN_RAM
(
pixel_clock,		// write clock
write_enable,		// write eanble
write_addr,			// write address
green_data,			// write data

pixel_clock,		// read clock
read_addr,			// read address
vga_green_data		// read data
);

VIDEO_RAM BLUE_RAM
(
pixel_clock,		// write clock
write_enable,		// write enable
write_addr,			// write address
blue_data,			// write data

pixel_clock,		// read clock
read_addr,			// read address
vga_blue_data		// read data
);

endmodule
