`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    15:14:07 03/12/2010 
// Design Name: 
// Module Name:    S_RECEIVER 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module S_RECEIVER(
RX_data,

CHANGE_STATE,
X,
Y,
spriteID,
draw
);

input [7:0]		RX_data;
input 			CHANGE_STATE;

output [15:0]	X;
output [15:0]	Y;
output [7:0]	spriteID;

output 			draw;

reg [15:0]	X;
reg [15:0]	Y;
reg [7:0]	spriteID;


reg [3:0] state, next_state;
//identifying bytes
parameter START_ID = 8'h24;
parameter STOP_ID = 8'h33;

//states

parameter START = 4'b0000;
//parameter START2 =4'b1000;
parameter SPRITE =4'b0001;
parameter X_1 = 	4'b0010;
parameter X_2 = 	4'b0011;
parameter Y_1 = 	4'b0100;
parameter Y_2 = 	4'b0101;
parameter STOP = 	4'b0110;

parameter IDLE = 	4'b0111;

reg reset2;
reg draw;

reg [7:0]	data;
reg [7:0]	temp_spriteID;
reg [7:0]  temp_X1, temp_X2;
reg [7:0]  temp_Y1, temp_Y2;
/*
assign led0 = ~spriteID[0];
assign led1 = ~spriteID[1];
assign led2 = ~spriteID[2];
assign led3 = ~draw;
*/
initial
begin
	X <= 200;
	Y <= 200;
	spriteID <= 8'b00000001; //should be '=', not '<=' ? maybe this is why the signals are messing up?
										//Maybe it takes these assignments to be permanent? oh wait, tempX isn't assigned
										//when X is overwritten?
	draw <= 0;	
	state <= START;
	next_state <= SPRITE;
	reset2 <= 0;
end


always @(posedge CHANGE_STATE) begin
	if(reset2 == 0)
		state[3:0] <= next_state[3:0];
	else begin
		state[3:0] <= START; //what if it's already start? does this trigger the sensitivity list?
	end
end

always @(state) begin
	case(state)
			START: 	next_state <= SPRITE;
			//START2: 	next_state <= SPRITE; // start to sprite
			SPRITE: 	next_state <= X_1;  // sprite to first half of x (X_1)
			X_1: 		next_state <= X_2;  // X_1 to second half of X(X_2)
			X_2: 		next_state <= Y_1;  // X_2 to first half of Y (Y_1)
			Y_1: 		next_state <= Y_2;  // Y_1 to second half of Y (Y_2)
			Y_2: 		next_state <= STOP;  // Y_2 to idle state, do we actually want Y_2 to go into start again?
			STOP: 	next_state <= IDLE;  // stop to idle
			IDLE: 	next_state <= START;  // IDLE to start
			default: next_state <= START;
	endcase
end

// This block does not function properly! It cycles through state, but does not perform loading functions! Yay!
always @(posedge CHANGE_STATE)
data <= RX_data; 

always @(data) // or CHANGE_STATE)
begin
case(state)
	START: begin 
				if(data != START_ID) reset2 <= 1; 
				else reset2 <= 0;
			end
	SPRITE: temp_spriteID[7:0] <= data[7:0];
	X_1: temp_X1[7:0] <= data[7:0];
	X_2: temp_X2[7:0] <= data[7:0];
	Y_1: temp_Y1[7:0] <= data[7:0];
	Y_2: temp_Y2[7:0]  <= data[7:0];
	STOP: begin
				if(data != STOP_ID) reset2 <= 1;
				else reset2 <= 0;
			end
	default: ;
endcase
end


//ahhh, the initial is coming from here! Trimming makes it so there's only a sprite on.
//then this pushes the X, Y, sprite before anything changes!
always @(state)
begin
//	reset2 <= 1;
	if(state == IDLE && reset2 != 1) begin
		X[15:8] 	<= temp_X1[7:0];
		X[7:0] 	<= temp_X2[7:0];
		Y[15:8]	<= temp_Y1[7:0];
		Y[7:0]	<= temp_Y2[7:0];
		spriteID[7:0] <= temp_spriteID[7:0];
		draw <= 1;
	end
	else
		draw <= 0;
end

endmodule
