`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    13:44:48 03/26/2010 
// Design Name: 
// Module Name:    TEST_RX 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module TEST_RX(
clk,

RX_TEST,
CHANGE_STATE
);

input 			clk;

output [7:0] 	RX_TEST;
output 			CHANGE_STATE;

reg [7:0] 		RX_TEST;
reg				CHANGE_STATE;

integer K;

parameter START_ID = 8'h24;
parameter STOP_ID = 8'h33;

parameter IDLE = 	4'b0000;
parameter START = 4'b0001;
parameter STOP = 	4'b0010;
parameter SPRITE =4'b0011;
parameter X_1 = 	4'b0100;
parameter X_2 = 	4'b0101;
parameter Y_1 = 	4'b0110;
parameter Y_2 = 	4'b0111;

parameter screenTime = 419200;

reg [3:0] state, next_state;

integer position;

initial
begin
	K <= 0;
	state <= START;
	next_state <= SPRITE;
	position <= 0;

end

always @ (posedge clk) begin
		if(K < screenTime) begin  //screenTime is the actual amount we want to output to screen?
			K = K + 1;
			CHANGE_STATE = 0;
			
		end
		else begin
			state <= next_state;
			K = 0;
			CHANGE_STATE = 1;
		end
end

always @(state) begin
	case(state)
		START: 	next_state <= SPRITE;  // start to sprite
		SPRITE: 	next_state <= X_1;  // sprite to first half of x (X_1)
		X_1: 		next_state <= X_2;  // X_1 to second half of X(X_2)
		X_2: 		next_state <= Y_1;  // X_2 to first half of Y (Y_1)
		Y_1: 		next_state <= Y_2;  // Y_1 to second half of Y (Y_2)
		Y_2: 		next_state <= STOP;  // Y_2 to idle state, do we actually want Y_2 to go into start again?
		STOP: 	next_state <= IDLE;
		default: next_state <= START;
	endcase
end

always @(state) begin	
	case(state)
		START: RX_TEST <= START_ID;
		SPRITE: RX_TEST <= 8'h01;
		X_1: RX_TEST <= 8'h00;
		X_2: RX_TEST <= 8'h64;
		Y_1: RX_TEST <= 8'h00;
		Y_2: RX_TEST  <= 8'h64;
		STOP: RX_TEST <= STOP_ID;
		IDLE: RX_TEST <= 8'h00;
	endcase
end



endmodule
